# Class ElementScanner14<R,P>

java.lang.Object
javax.lang.model.util.AbstractElementVisitor6<R,P>
javax.lang.model.util.ElementScanner6<R,P>
javax.lang.model.util.ElementScanner7<R,P>
javax.lang.model.util.ElementScanner8<R,P>
javax.lang.model.util.ElementScanner9<R,P>
javax.lang.model.util.ElementScanner14<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `ElementVisitor<R,P>`

Direct Known Subclasses:
  `ElementScannerPreviewPREVIEW`

@SupportedSourceVersion(RELEASE_25) public class ElementScanner14<R,P> extends ElementScanner9<R,P>
A scanning visitor of program elements with default behavior appropriate for the `RELEASE_14` source version. The `visitXyz` methods in this class scan their component elements by calling `scan` on their enclosed elements, parameters, etc., as indicated in the individual method specifications. A subclass can control the order elements are visited by overriding the `visitXyz` methods. Note that clients of a scanner may get the desired behavior by invoking `v.scan(e, p)` rather than `v.visit(e, p)` on the root objects of interest.

When a subclass overrides a `visitXyz` method, the new method can cause the enclosed elements to be scanned in the default way by calling `super.visitXyz`. In this fashion, the concrete visitor can control the ordering of traversal over the component elements with respect to the additional processing; for example, consistently calling `super.visitXyz` at the start of the overridden methods will yield a preorder traversal, etc. If the component elements should be traversed in some other order, instead of calling `super.visitXyz`, an overriding visit method should call `scan` with the elements in the desired order.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  16
See Also:
  - Compatibility note for subclasses
  - `ElementScanner6`
  - `ElementScanner7`
  - `ElementScanner8`
  - `ElementScanner9`

## Field Summary

### Fields declared in class ElementScanner6

`DEFAULT_VALUE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`ElementScanner14()`
Constructor for concrete subclasses; uses `null` for the default value.
`protected`
`ElementScanner14(R defaultValue)`
Constructor for concrete subclasses; uses the argument for the default value.

## Method Summary

Modifier and Type
Method
Description
`R`
`visitExecutable(ExecutableElement e, P p)`
Visits an executable element.
`R`
`visitRecordComponent(RecordComponentElement e, P p)`
Visits a record component element.
`R`
`visitType(TypeElement e, P p)`
Visits a type element.

### Methods declared in class ElementScanner9

`visitModule`

### Methods declared in class ElementScanner7

`visitVariable`

### Methods declared in class ElementScanner6

`scan, scan, scan, visitPackage, visitTypeParameter`

### Methods declared in class AbstractElementVisitor6

`visit, visit, visitUnknown`

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### ElementScanner14

protected ElementScanner14()
Constructor for concrete subclasses; uses `null` for the default value.

### ElementScanner14

protected ElementScanner14(R defaultValue)
Constructor for concrete subclasses; uses the argument for the default value.

Parameters:
  `defaultValue` - the default value

## Method Details

### visitType

public R visitType(TypeElement e, P p)
Visits a type element.

Specified by:
  `visitType` in interface `ElementVisitor<R,P>`
Overrides:
  `visitType` in class `ElementScanner6<R,P>`
Implementation Requirements:
  This implementation scans the type parameters, if any, and then the enclosed elements.
Parameters:
  `e` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of scanning

### visitExecutable

public R visitExecutable(ExecutableElement e, P p)
Visits an executable element.

Specified by:
  `visitExecutable` in interface `ElementVisitor<R,P>`
Overrides:
  `visitExecutable` in class `ElementScanner6<R,P>`
Implementation Requirements:
  This implementation first scans the type parameters, if any, and then the parameters.
Parameters:
  `e` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of scanning

### visitRecordComponent

public R visitRecordComponent(RecordComponentElement e, P p)
Visits a record component element.

Specified by:
  `visitRecordComponent` in interface `ElementVisitor<R,P>`
Overrides:
  `visitRecordComponent` in class `ElementScanner6<R,P>`
Implementation Requirements:
  This implementation scans the enclosed elements.
Parameters:
  `e` - the element to visit
  `p` - a visitor-specified parameter
Returns:
  the result of scanning